<template>
  <div class="app-container calendar-list-container" v-loading.body="showLoadingBody">
    <div v-if="!oneCampsiteDialogVisible">
      <div class="filter-container" ref="filter-container">
        <el-form ref="queryForm" :inline="inline" :model="listQuery" label-width="100px">
          <el-row>
						<el-col :span="8">
						  <el-form-item label="标题">
						    <el-input v-model.number="listQuery.title" placeholder="请输入标题"></el-input>
						  </el-form-item>
						</el-col>
            <!--<el-col :span="8">-->
              <!--<el-form-item label="时间">-->
                <!--<el-date-picker-->
                  <!--v-model="listQuery.startTime"-->
                  <!--type="date"-->
                  <!--clearable-->
                  <!--placeholder="选择日期">-->
                <!--</el-date-picker>~-->
                <!--<el-date-picker-->
                  <!--v-model="listQuery.endTime"-->
                  <!--type="date"-->
                  <!--clearable-->
                  <!--placeholder="选择日期">-->
                <!--</el-date-picker>-->
              <!--</el-form-item>-->
            <!--</el-col>-->
          </el-row>
        </el-form>
        <el-button class="filter-item" type="primary" v-waves icon="search" @click="handleFilter">搜索</el-button>
        <el-button class="filter-item" style="margin-left: 10px;" @click="handleCreate"
                   type="primary" icon="edit" v-if="campsite_btn_save">添加
        </el-button>
      </div>
      <el-table :key='tableKey' :data="list" border fit highlight-current-row
                style="width: 100%">
        <el-table-column type="index" align="center" label="序号" width="65">
        </el-table-column>
         <el-table-column width="150" align="center" label="活动图片">
          <template scope="scope">
        		<img v-if="$utils.isString(scope.row.banner) && !$utils.isEmpty(scope.row.banner)" :src="scope.row.banner" style="width:100px;max-height:100px;">
          </template>
        </el-table-column>
        
				<el-table-column align="center" width="200" label="标题">
          <template scope="scope">
            <img :src="scope.row.cover" style="width: 30px;"/>
            <span>{{scope.row.title}}</span>
          </template>
        </el-table-column>

        <el-table-column width="200" align="center" label="副标题">
          <template scope="scope">
            <span>{{scope.row.subtitle}}</span>
          </template>
        </el-table-column>
				
				
        <el-table-column width="200" align="center" label="活动对象说明">
          <template scope="scope">
            <span>{{scope.row.actDesc}}</span>
          </template>
        </el-table-column>

				<el-table-column width="100" align="center" label="总人数">
          <template scope="scope">
            <span>{{scope.row.limitNum}}</span>
          </template>
        </el-table-column>
				<el-table-column width="200" align="center" label="活动地址">
				  <template scope="scope">
				    <span>{{scope.row.province}}{{scope.row.city}}{{scope.row.town}}{{scope.row.address}}</span>
				  </template>
				</el-table-column>
				<el-table-column width="200" align="center" label="活动时间">
				  <template scope="scope">
				    <span>{{scope.row.starTimetStr}}</span><br/>
							 ~<br />
						<span>{{scope.row.endTimeStr}}</span>
				  </template>
				</el-table-column>

        <el-table-column align="center" width="200" label="创建时间">
          <template scope="scope">
            <span>{{scope.row.crtTimeStr}}</span>
          </template>
        </el-table-column>
        <el-table-column align="center" width="200" label="操作" fixed="right">
          <template scope="scope">
            <el-button size="small"  class="el-button el-button--text el-button--small" @click="handleUpdate(scope.row)">{{campsiteshop_btn_update?"编辑":"查看"}}
            </el-button>
            <el-button size="small"  class="el-button el-button--text el-button--small" v-if="(scope.row.isShow==0) && campsiteshop_btn_update_salestatus" @click="isShowStatus(scope.row)">上架
            </el-button>
            <el-button size="small"  class="el-button el-button--text el-button--small" v-if="scope.row.isShow==1 && campsiteshop_btn_update_salestatus" @click="isShowStatus(scope.row)">下架
            </el-button>
						 <el-button size="small"  class="el-button el-button--text el-button--small" v-if="(scope.row.isPublish==0) && campsiteshop_btn_update_salestatus" @click="isPublishStatus(scope.row)">发布
						</el-button>
						<el-button size="small"  class="el-button el-button--text el-button--small" v-if="scope.row.isPublish==1 && campsiteshop_btn_update_salestatus" @click="isPublishStatus(scope.row)">不发布
						</el-button>
						 <el-button size="small"  class="el-button el-button--text el-button--small" v-if="(scope.row.isHomePage==0) && campsiteshop_btn_update_salestatus" @click="isHomePageStatus(scope.row)">置顶
						</el-button>
						<el-button size="small"  class="el-button el-button--text el-button--small" v-if="scope.row.isHomePage==1 && campsiteshop_btn_update_salestatus" @click="isHomePageStatus(scope.row)">不置顶
						</el-button>
            <el-button  class="el-button el-button--text el-button--small" style="color:red;" size="small" @click="deleteHandler(scope.row)" v-if="campsiteshop_btn_del">删除</el-button>
          </template>
        </el-table-column>
      </el-table>
      <div v-show="!listLoading" class="pagination-container">
        <el-pagination @size-change="handleSizeChange" @current-change="handleCurrentChange"
                       :current-page.sync="listQuery.page" :page-sizes="[10,20,30,40]" :page-size="listQuery.limit"
                       layout="total, sizes, prev, pager, next, jumper" :total="total"></el-pagination>
      </div>
    </div>
    <!-- 营地modal弹窗 -->
    <oneCampsite v-if="oneCampsiteDialogVisible" :campsiteshop_btn_update="campsiteshop_btn_update" :oneRow="oneRow"  :title="modalTitle" v-on:oneCampsiteDialogEvent = "oneCampsiteDialogEvent"></oneCampsite>
  </div>
</template>

<script>
  import oneCampsite from './modal/oneCampsiteModal'// 营地
  import 'static/css/uploadImg.css';// 引入图片上传组件对话框

  import {
    formatDate
  } from 'utils/dateFormattor';

  import {
    toEast8Date,
    deepCopyDate,
    newEast8Date,
    convertDate2Str,
    timestamp2Date
  } from 'utils/dateUtils';

  import rsCode from '../../utils/rsCode';

  import {mapGetters} from 'vuex';
  import {
    getToken
  } from 'utils/auth';
import {
	getActivityList,
	isShowStatus,
	isPublishStatus,
	isHomePageStatus,
	deleteActivityTag
} from '../../api/officialWebsit/activity';
  import Element1 from "../admin/menu/components/element";
  import ElRow from "element-ui/packages/row/src/row";
  import ElCol from "element-ui/packages/col/src/col";

  export default {
    name: 'tourManage',
    components: {
      ElCol,
      ElRow,
      Element1,
      oneCampsite
    },
    data() {
      return {
        modalTitle: "创建",
        BASE_API: process.env.BASE_API,
        oneCampsiteDialogVisible: false,//添加、编辑弹框
        showLoadingBody: false,
        form: {
          tagNames:"",//标签
          name: undefined,//旅游名称
          saleCount: undefined,//销量
          stock: undefined,//总数量
        },
        list: null,
        total: null,
        listLoading: true,
        listQuery: {
          page: 1,
          limit: 20,
          startTime: undefined,
          endTime:undefined,
          title: '',//关键词
        },
        inline: true,
        textMap: {
          update: '编辑',
          create: '创建'
        },
        tableKey: 0,
        campsite_btn_save: false,//添加
        campsiteshop_btn_update: false,//编辑
        campsiteshop_btn_update_salestatus:false,//上下架
        campsiteshop_btn_del: false,//删除
      }
    },
    created() {
      this.campsite_btn_save = this.elements['campsite:btn_save'];
      this.campsiteshop_btn_update = this.elements['campsiteshop:btn_update'];
      this.campsiteshop_btn_update_salestatus = this.elements['campsiteshop:btn_update_salestatus'];
      this.campsiteshop_btn_del = this.elements['campsiteshop:btn_del'];
      this.getList();
    },
    computed: {
      ...mapGetters([
        'elements'
      ])
    },
    methods: {
      /**
       * 添加
       * */
      handleCreate() {
        this.resetTemp();
        this.oneRow = {};
        this.modalTitle = '创建';
        this.oneCampsiteDialogVisible = true;
      },
      /**
       * 操作-删除
       * */
      deleteHandler(row) {
        this.$confirm('确定删除吗?', '提示', {
          confirmButtonText: '确定',
          cancelButtonText: '取消',
          type: 'warning'
        }).then(() => {
          deleteActivityTag(row.id).then(response => {
            if (response.status === 200) {
              this.$notify({
                title: '成功',
                message: '删除成功',
                type: 'success',
                duration: 2000
              });
              this.oneCampsiteDialogVisible = false;
              this.getList();
            } else {
              this.$notify({
                title: '删除失败',
                message: rsCode.msg[response.code] ? rsCode.msg[response.code] : '操作失败！',
                type: 'error',
                duration: 2000
              });
            }
          });
        })
      },
      /**
       * 上架、下架  参数 id status 1-上架；2-下架  post
       */
      isShowStatus(row){
        let params = {
          id: row.id,
          state: row.isShow== 1 ? 0 : 1
        };
        isShowStatus(params.id, params.state).then(response => {
          if (response.status === 200) {
            this.$notify({
              title: '成功',
              message: '成功',
              type: 'success',
              duration: 2000
            });
            this.oneCampsiteDialogVisible = false;
            this.getList();
          } else {
            this.$notify({
              title: '失败',
              message: rsCode.msg[response.code] ? rsCode.msg[response.code] : '操作失败！',
              type: 'error',
              duration: 2000
            });
          }
        });
      },
			
			/**
			 * 上架、下架  参数 id status 1-上架；2-下架  post
			 */
			isPublishStatus(row){
			  let params = {
			    id: row.id,
			    state: row.isPublish== 1 ? 0 : 1
			  };
			  isPublishStatus(params.id, params.state).then(response => {
			    if (response.status === 200) {
			      this.$notify({
			        title: '成功',
			        message: '成功',
			        type: 'success',
			        duration: 2000
			      });
			      this.oneCampsiteDialogVisible = false;
			      this.getList();
			    } else {
			      this.$notify({
			        title: '失败',
			        message: rsCode.msg[response.code] ? rsCode.msg[response.code] : '操作失败！',
			        type: 'error',
			        duration: 2000
			      });
			    }
			  });
			},
				/**
			 * 是否置顶  参数 id status 1-上架；2-下架  post
			 */
			isHomePageStatus(row){
			  let params = {
			    id: row.id,
			    state: row.isHomePage== 1 ? 0 : 1
			  };
			  isHomePageStatus(params.id, params.state).then(response => {
			    if (response.status === 200) {
			      this.$notify({
			        title: '成功',
			        message: '成功',
			        type: 'success',
			        duration: 2000
			      });
			      this.oneCampsiteDialogVisible = false;
			      this.getList();
			    } else {
			      this.$notify({
			        title: '失败',
			        message: rsCode.msg[response.code] ? rsCode.msg[response.code] : '操作失败！',
			        type: 'error',
			        duration: 2000
			      });
			    }
			  });
			},
      /**
       * 编辑
       * */
      handleUpdate(row) {
        this.modalTitle = '编辑';
        this.oneRow = row;
        this.oneCampsiteDialogVisible = true;
      },
      /**
       * 下架
       * */
      undercarriageHandler(row) {
        // open dialog
        this.departureDialogVisible = true;
        this.clearDepartureForm();
        let that = this;
        let selectArry = [];
        this.allCompaniesArr.map(function(item){
          item.value = item.name;
          selectArry.push(item);
        });
        this.departureForm.mileage = row.mileage;
        this.departureForm.expectArrivalBranchCompanyId = row.subordinateBranch;
        this.departureForm.departureBranchCompanyId = row.subordinateBranch;
        selectArry.map(function (iitem) {
          if( row.subordinateBranch == iitem.id){
            that.departureForm.departureBranchCompanyName = iitem.name;
            that.departureForm.expectArrivalBranchCompanyName = iitem.name;
          }
        });
        this.departureForm.vehicleId = row.id;
        this.departureForm.numberPlate = row.numberPlate;
        this.departureForm.departureDate = Date();
      },
      /**
       * 旅游modal传递回来的数据
       * */
      oneCampsiteDialogEvent(e){
        this.oneCampsiteDialogVisible = false;
        if(!e){//关闭编辑
          this.oneCampsiteDialogVisible = e;
        } else if(e){
          //编辑成功-重新加载列表
          this.getList();
        }
      },
      /**
       * 获取旅游列表
       * */
      getList() {
        this.listLoading = true;
        if(this.listQuery.startTime){
          this.listQuery.startTime = this.listQuery.startTime.getTime();
        }
        if(this.listQuery.endTime){
          this.listQuery.endTime = this.listQuery.endTime.getTime();
        }
        getActivityList(this.listQuery).then(response => {
          let totalCountRs = undefined;
          let listRs = undefined;
          if (!this.$utils.isEmpty(response.data.data) && this.$utils.isInteger(response.data.totalCount)) {
            listRs = response.data.data;
            totalCountRs = response.data.totalCount;
            listRs.map(function(item){
              item.visible2 = false;
              item.crtTimeStr = timestamp2Date(item.crtTime);
							item.starTimetStr = timestamp2Date(item.startTime);
							item.endTimeStr = timestamp2Date(item.endTime);
            });
          }
          this.listLoading = false;
          this.list = listRs;
          this.total = totalCountRs;
        })

      },
      getAddrStr(branchCompany) {
        let regions = getRegionByCodes([branchCompany.addrProvince, branchCompany.addrCity, branchCompany.addrTown]);
        let address = [];
        for(let i = 0; i < regions.length; i++){
          address.push(regions[i].name);
        }
        return address.join(" ");
      },
      handleFilter() {
        this.listQuery.page = 1;
        this.$refs.queryForm.validate(valid => {
          if (valid) {
            this.getList();
          } else {
            return false;
          }
        });
      },
      handleSizeChange(val) {
        this.listQuery.limit = val;
        this.getList();
      },
      handleCurrentChange(val) {
        this.listQuery.page = val;
        this.getList();
      },


      /**
       * 操作-申请预定
       * */
      handleApply(row) {
        this.resetTemp4Apply();
        let that = this;
        let selectArry = [];
        this.allCompaniesArr.map(function(item){
          item.value = item.name;
          selectArry.push(item);
        });
        this.form4Apply.liftCompany = row.subordinateBranch;
        selectArry.map(function (iitem) {
          if( row.subordinateBranch == iitem.id){
            that.form4Apply.state3 = iitem.name;
          }
        });
        this.form4Apply.vehicle = row.id;
        getBookedInfoIn2Month(row.id)
          .then(response => {
            this.curBookedInfo3Month = response.data;
            this.dialogStatus = 'apply';
            this.dialogForm4ApplyVisible = true;
          });
      },
      handleBookInfo(row) {
        this.$refs.bookInfoViewer.handleBookInfo(row.id);
      },
      create(formName) {
        const set = this.$refs;
        if(!this.form.state2 || this.form.state2 == "全部"){
          this.form.subordinateBranch = undefined;
          this.$notify({
            title: '失败',
            message: '请选择分公司',
            type: 'warning',
            duration: 2000
          });
          return;
        }
        set[formName].validate(valid => {
          if (valid) {
            let formTemp = this.fillDateRange2Object(this.form, 'insuranceDateRange4form', 'insuranceStartDate', 'insuranceEndDate');
            convertDate2Str(formTemp);
            addObj(formTemp)
              .then(response => {
                if (response.code === rsCode.RS_CODE_SUC) {
                  this.dialogFormVisible = false;
                  this.getList();
                  this.$notify({
                    title: '成功',
                    message: '创建成功',
                    type: 'success',
                    duration: 2000
                  });
                  this.getList();
                } else {
                  this.$notify({
                    title: '失败',
                    message: rsCode.msg[response.code] ? rsCode.msg[response.code] : '操作失败！',
                    type: 'error',
                    duration: 2000
                  });
                }
              });
          } else {
            return false;
          }
        });
      },
      cancel(formName) {
        this.dialogFormVisible = false;
        this.dialogForm4ApplyVisible = false;
        this.$refs[formName].resetFields();
      },
      cancel4Apply(formName) {
        this.dialogForm4ApplyVisible = false;
        this.$refs[formName].resetFields();
      },
      update(formName) {
        const set = this.$refs;
        if(!this.form.state2 || this.form.state2 == "全部"){
          this.form.subordinateBranch = undefined;
          this.$notify({
            title: '失败',
            message: '请选择分公司',
            type: 'warning',
            duration: 2000
          });
          return;
        }
        set[formName].validate(valid => {
          if (valid) {
            let formTemp = this.fillDateRange2Object(this.form, 'insuranceDateRange4form', 'insuranceStartDate', 'insuranceEndDate');
            convertDate2Str(formTemp);
            putObj(formTemp).then(response => {
              if (response.code === rsCode.RS_CODE_SUC) {
                this.dialogFormVisible = false;
                this.getList();
                this.$notify({
                  title: '成功',
                  message: '更新成功',
                  type: 'success',
                  duration: 2000
                });
                this.getList();
              } else {
                this.$notify({
                  title: '失败',
                  message: rsCode.msg[response.code] ? rsCode.msg[response.code] : '操作失败！',
                  type: 'error',
                  duration: 2000
                });
              }
            });
          } else {
            return false;
          }
        });
      },
      /**
       * 申请预定-确定
       * @param formName
       */
      apply(formName) {
        if(!this.form4Apply.state3 || this.form4Apply.state3 == "全部"){
          this.form4Apply.liftCompany = undefined;
          this.$notify({
            title: '失败',
            message: '请选择提车分公司',
            type: 'warning',
            duration: 2000
          });
          return;
        }
        if(!this.form4Apply.state4 || this.form4Apply.state4 == "全部"){
          this.form4Apply.retCompany = undefined;
          this.$notify({
            title: '失败',
            message: '请选择还车分公司',
            type: 'warning',
            duration: 2000
          });
          return;
        }
        const set = this.$refs;
        set[formName].validate(valid => {
          if (valid) {
            this.dialogFormVisible = false;
            book(this.form4Apply).then(() => {
              this.dialogForm4ApplyVisible = false;
              this.getList();
              this.$notify({
                title: '成功',
                message: '预定成功',
                type: 'success',
                duration: 2000
              });
            });
          } else {
            return false;
          }
        });
      },
      resetTemp() {
        this.form = {
          tagNames:"",//标签
          name: undefined,//旅游名称
          saleCount: undefined,//销量
          stock: undefined,//总数量
        };
      },
      resetTemp4Apply() {
        this.form4Apply = {
          bookStartDate: undefined,
          bookEndDate: undefined,
          state3: '',
          state4:'',
          retCompany: undefined,
          vehicle: undefined,
          selectedAccItem: undefined,
          liftCompany: undefined,
          liftAddr: undefined,
          destination: undefined,
          remark: undefined
        };
      },
      resetTemp4BookInfo() {
        this.form4BookInfo = {
          selectedMonth: this.$utils.toDateString(newEast8Date(), 'yyyy-MM'),
          vehicle: undefined
        };
      }
    }
  }
</script>
